import React, { Component } from 'react';
import NavBar from './navbar';
import Boxes from './boxes';

class App extends Component {
    state = { 
        boxes: [
            {id: 1, x: 1},
            {id: 2, x: 2},
            {id: 3, x: 3},
            {id: 4, x: 4},
        ]
     } 

    //  constructor() {
    //     super();
    //     console.log("App---constructed");
    //  }

    //  componentDidUpdate(prevProps,prevState) {
    //     console.log("prevState",prevState,this.state); // 为什么打印出来的数据是相同的
    //  }


    //  componentDidMount() {
    //     console.log("App---Mounted");
    //  }


    // 每个组件的state只能在该组件内访问！！！！
    handleDelete = (BoxId) => {
        // 保留所有id不同于BoxId的元素
        const boxes = this.state.boxes.filter(box => box.id !== BoxId);
        this.setState({boxes: boxes});

    }

    handleReset = () => {
        // const boxes = this.state.boxes.map(box => {
        //     return {
        //         id: box.id,
        //         x: box.id,
        //     }
        // });

        const boxes = [
                {id: 1, x: 1},
                {id: 2, x: 2},
                {id: 3, x: 3},
                {id: 4, x: 4},
        ]

        this.setState({boxes:boxes});
    }

    handleClickLeft = (box,step) => {
        const boxes = [...this.state.boxes]; // 浅拷贝
        const k = boxes.indexOf(box); // box对应的index
        boxes[k].x = Math.max(0,boxes[k].x - step);// 修改state中的x值
        this.setState({boxes});

    }

    handleClickRight = (box,step) => {
        const boxes = [...this.state.boxes]; // 浅拷贝
        const k = boxes.indexOf(box); // box对应的index
        boxes[k].x = Math.min(1000,boxes[k].x + step); // 修改state中的x值
        this.setState({boxes});
    }

    render() { 
        console.log("App---Rendered");
        return (
            <React.Fragment>
                <NavBar 
                    boxNumberCount={this.state.boxes.filter(b => b.x <= 10).length}
                ></NavBar>
                <Boxes 
                    boxes={this.state.boxes}
                    onReset={this.handleReset}
                    onDelete={this.handleDelete}
                    onLeft={this.handleClickLeft}
                    onRight={this.handleClickRight}
                ></Boxes>
            </React.Fragment>
        );
    }
}
 
export default App;