import React, { Component } from 'react';


class Solutions extends Component {
    state = { 
        solutions: [
            {key: 10,number: 3331,title: "交换数值_10",views: 1111},
            {key: 11,number: 3332,title: "交换数值_11",views: 1112},
            {key: 12,number: 3333,title: "交换数值_12",views: 1113},
            {key: 13,number: 3334,title: "交换数值_13",views: 1114},
            {key: 14,number: 3335,title: "交换数值_14",views: 1115},
            {key: 15,number: 3336,title: "交换数值_15",views: 1116},
            {key: 16,number: 3337,title: "交换数值_16",views: 1117},
            {key: 17,number: 3338,title: "交换数值_17",views: 1118},
        ]
     } 


    btn_style = {
        margin: "0px 0px 0px 20px",
    }

    handleInsert = () => {
        let k = this.state.solutions.length;
        const solutions = [...this.state.solutions, {
            key: this.state.solutions[k-1]['key'] + 1, number:this.state.solutions[k-1]['number'] + 1,title: `交换数值_${this.state.solutions[k-1].key+1}`,views: this.state.solutions[k-1]['views'] + 1,
        }];
        this.setState({
            solutions: solutions,
        })
    }

    handleDelete = (s) => {
        // 保留和当前元素不同的其他元素，只删除对应元素
        const solutions = this.state.solutions.filter(solution => solution !== s);
        this.setState({
            solutions: solutions,
        })
    }
    render() { 

        if (this.state.solutions.length === 0) {
            return (
            <div id="warning">
            <div className="alert alert-danger d-flex align-items-center" role="alert">
            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="currentColor" className="bi bi-exclamation-triangle-fill flex-shrink-0 me-2" viewBox="0 0 16 16" role="img" aria-label="Warning:">
                <path d="M8.982 1.566a1.13 1.13 0 0 0-1.96 0L.165 13.233c-.457.778.091 1.767.98 1.767h13.713c.889 0 1.438-.99.98-1.767L8.982 1.566zM8 5c.535 0 .954.462.9.995l-.35 3.507a.552.552 0 0 1-1.1 0L7.1 5.995A.905.905 0 0 1 8 5zm.002 6a1 1 0 1 1 0 2 1 1 0 0 1 0-2z"/>
            </svg>
            <div>
                 没有更多的题解了
            </div>
            </div>
            </div>
            );
        }
        return (
            <React.Fragment>
            <nav className="navbar navbar-expand-lg navbar-light bg-light">
            <div className="container-fluid">
            <span className="navbar-brand">题解列表</span>
            </div>
            </nav>

            <table className="table">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>标题</th>
                        <th>阅读量</th>
                        <th>操作</th>
                    </tr>
                </thead>
                <tbody>
                    {this.state.solutions.map(solution => (
                        <tr key={solution.key}>
                            <td>{solution.number}</td>
                            <td>{solution.title}</td>
                            <td>{solution.views}</td>
                            <td>
                                <button className='btn btn-danger sm' onClick={() => this.handleDelete(solution)}>删除</button>
                                <button className='btn btn-success sm' onClick={() => this.handleInsert()} style={this.btn_style}>添加</button>
                            </td>
                        </tr>
                        ))}
                </tbody>
            </table>
            </React.Fragment>
        );
    }
}
 
export default Solutions;